/*
** EPITECH PROJECT, 2023
** B-OOP-400-PAR-4-1-tekspice-jean-cyprien.roux
** File description:
** IComponent
*/
#ifndef ICOMPONENT_HPP_
	#define ICOMPONENT_HPP_
#include <cstddef>
#include <map>
#include <iostream>
#include <vector>


namespace nts {

    enum Tristate {
        UNDEFINED = (-true),
        TRUE = true,
        FALSE = false,
        NOT_SET = 42 
    };
    class IComponent {
        public:
            virtual ~IComponent(void){};
            virtual void simulate(std::size_t tick) = 0;
            virtual nts::Tristate compute(std::size_t pin) = 0;
            virtual void setLink(std::size_t pin, nts::IComponent &other, std::size_t otherPin) = 0;
    };
}

#endif /*ICOMPONENT_HPP_*/