/*
** EPITECH PROJECT, 2023
** Bootsrap
** File description:
** NorComponent.hpp
*/
#ifndef NORCOMPONENT_HPP_
	#define NORCOMPONENT_HPP_

#include "AComponent.hpp"

namespace nts {
    class NorComponent : public nts::AComponent {
        public:
            NorComponent();
            ~NorComponent();
            nts::Tristate compute(std::size_t pin);
            std::vector<Pin> * getLinks();
            const std::vector<Pin> * getLinks() const;
            void display(std::ostream &os);
            void setStates(nts::Tristate state) {};

    private:
            std::vector<Pin> links = std::vector<Pin> (3);
    };
};

#endif /*NORCOMPONENT_HPP_*/